#include <stdio.h>
#include <motelib/system.h>
#include <motelib/led.h>
#include <motelib/timer.h>
#include <motelib/radio.h>
#include <motelib/uart.h>
#include <motelib/actor.h>

void Ready(){
    actorSetState(ACTOR_0,0);
    actorSetState(ACTOR_1,0);
    actorSetState(ACTOR_2,0);
    actorSetState(ACTOR_3,0);
}

Timer t;

void recv(Address source, MessageType type, void* msg, uint8_t len)
{	
		//left turn
  		if(type==2){
  			printf("Turn Left\n");
			actorSetState(ACTOR_0,1);
            timerStart(&t, TIMER_ONESHOT,100,Ready);
  		}
  		//right turn
  		if(type==3){
  			printf("Turn Right\n");
  			actorSetState(ACTOR_1,1);
        	timerStart(&t, TIMER_ONESHOT,100,Ready);
  		}
  		if(type==4){
  			printf("RELOAD\n");
  			actorSetState(ACTOR_2,1);
        	timerStart(&t, TIMER_ONESHOT,100,Ready);
  		}
  		if(type==5){
  			printf("FIRE!!!!\n");
  			actorSetState(ACTOR_3,1);
        	timerStart(&t, TIMER_ONESHOT,100,Ready);
  		}  		
}

void boot()
{
	uartEnable(true, true); 
    timerCreate(&t);
    radioSetRxHandler(recv);
}
